<template>
    <section>

        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span class="h4" v-if="fail">
                    {{ fail.message }} <br>
                    <a href="#" class="btn btn-outline-primary mt-3" v-on:click.prevent="loadAd">Retry</a>
                </span>
            </div>
        </template>

        <template v-else>
            <span style="float: right; position: relative"><router-link v-bind:to="'/advertiser/my-ads/' + ad.id + '/edit'" class="font-weight-bold h5 mb-0"><i class="far fa-edit"></i> EDIT</router-link> </span>

            <h2 class="pb-2 mb-2">{{ ad.name }}</h2>

            <div class="card p-3 bg-transparent">
                <h3 class="card-title">Summary</h3>
                <div class="card-body row">
                    <div class="col-3">
                        <span class="h3">{{ ad.view_count }}</span>
                        <br>Impressions
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ ad.click_count }}</span>
                        <br>Clicks
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ Number((ad.click_count / ad.view_count) * 100).toFixed(2) }}</span>
                        <br>CTR
                    </div>

                    <div class="col-3">
                        <span class="h3">Br Br {{ Number((ad.view_count * 0.5) + (ad.click_count * 1.5)).toFixed(2) }}</span>
                        <br>Cost
                    </div>
                </div>
            </div>

            <hr>

            <h4>Recent Ad Clicks</h4>

            <table class="table table-hover">
                <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Content</th>
                    <th scope="col">Type</th>
                    <th scope="col">Timestamp</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="click, key in ad.clicks">
                    <th scope="row">{{ key + 1 }}</th>
                    <td>{{ click.content.name }}</td>
                    <td>{{ click.content.type }}</td>
                    <td>{{ click.content.created_at }}</td>
                </tr>
                </tbody>
            </table>

            <h4>Recent Ad Impressions</h4>

            <table class="table table-hover">
                <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Content</th>
                    <th scope="col">Type</th>
                    <th scope="col">Timestamp</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="view, key in ad.views">
                    <th scope="row">{{ key + 1 }}</th>
                    <td>{{ view.content.name }}</td>
                    <td>{{ view.content.type }}</td>
                    <td>{{ view.content.created_at }}</td>
                </tr>
                </tbody>
            </table>
        </template>



    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                adId: this.$route.params.id,
                ad: null,

                // Loading
                loading: false,

                // Fail Flag
                fail: false
            }
        },
        methods: {
            loadAd: function () {
                // Show Loading
                this.loading = true;

                // Clear previous status flags
                this.fail = false;

                // Make a request to the server
                axios.get('/api/advertiser/ads/' + this.adId)
                    .then(response => {
                        this.ad = response.data
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        watch: {
            '$route.params.id': function(id) {
                this.adId = id;
                this.loadAd();
            }
        },
        mounted() {
            // Load the ad
            this.loadAd();

            console.log('Advertiser - Ad mounted.')
        }
    }
</script>
